MVVM-like operations on the displayed score.

All operations that can be performed on a 'live' score go through this module. It maps the score view to the actual score and makes sure the model and view stay in sync.

Because this object operates on the current selections, all operations return promise so applications can wait for the operation to complete and update the selection list.

### Hierarchy

- SuiScoreView
  - SuiScoreViewOperations

## Index

### Constructors

- constructor

### Accessors

- defaultStaffMap

### Methods

- _changeActiveVoice
- _getEquivalentGraceNote
- _getEquivalentSelection
- _getEquivalentSelections
- _getEquivalentSelector
- _getEquivalentStaff
- _getRectangleSelections
- _mapPartFormatting
- _removeDynamic
- _renderChangedMeasures
- _renderRectangle
- _setPageLayout
- _setTransposing
- _undoColumn
- _undoFirstMeasureSelection
- _undoScore
- _undoScorePreferences
- _undoSelection
- _undoSelections
- _undoStaffModifier
- _undoTrackerMeasureSelections
- accelerando
- addDynamic
- addEnding
- addGraceNote
- addKeySignature
- addMeasure
- addMeasures
- addOrUpdateStaffGroup
- addOrUpdateStaffModifier
- addRemoveMicrotone
- addStaffSimple
- addTextGroup
- advanceModifierSelection
- batchDurationOperation
- beamSelections
- changeInstrument
- changeScore
- collapseChord
- copy
- crescendo
- crescendoBracket
- decrescendo
- deleteMeasure
- deleteNote
- depopulateVoice
- dimenuendo
- exposePart
- getFocusedPage
- getView
- groupUndo
- growSelectionLeft
- growSelectionRight
- growSelectionRightMeasure
- intersectingArtifact
- isPartExposed
- loadRemoteJson
- loadRemoteScore
- loadRemoteXml
- makeRest
- makeTuplet
- moveEnd
- moveHome
- moveSelectionDown
- moveSelectionLeft
- moveSelectionLeftMeasure
- moveSelectionPitchDown
- moveSelectionPitchUp
- moveSelectionRight
- moveSelectionRightMeasure
- moveSelectionUp
- moveStaffUpDown
- paste
- playFromSelection
- populateVoice
- quickSave
- refreshViewport
- removeDynamic
- removeGraceNote
- removeLyric
- removeStaff
- removeStaffModifier
- removeSystemBreaks
- removeTempo
- removeTextGroup
- renderPromise
- ritard
- selectSuggestion
- setChordFont
- setEngravingFontFamily
- setGlobalLayout
- setInterval
- setLyricFont
- setMappedStaffIds
- setMeasureFormat
- setNoteHead
- setPitch
- setPitchPiano
- setPitchesPromise
- setTimeSignature
- setView
- showPiano
- slashGraceNotes
- slur
- startRenderingEngine
- tie
- toggleArticulation
- toggleBeamDirection
- toggleBeamGroup
- toggleCourtesyAccidentals
- toggleEnharmonic
- toggleRehearsalMark
- toggleSlash
- transposeSelections
- undo
- unmakeTuplet
- updatePartInfo
- updatePromise
- updateScoreInfo
- updateScorePreferences
- updateTempoScore
- updateTextGroup
- viewAll
- waitableAction

## Constructors

### constructor

- new SuiScoreViewOperations(config: SmoRenderConfiguration, svgContainer: HTMLElement, score: SmoScore, scrollSelector: HTMLElement, undoBuffer: UndoBuffer): SuiScoreViewOperations

- Inherited from SuiScoreView.constructor

  - Defined in src/render/sui/scoreView.ts:52

  #### Parameters

  - ##### config: SmoRenderConfiguration

  - ##### svgContainer: HTMLElement

  - ##### score: SmoScore

  - ##### scrollSelector: HTMLElement

  - ##### undoBuffer: UndoBuffer

  #### Returns SuiScoreViewOperations

## Accessors

### defaultStaffMap

- get defaultStaffMap(): number[]

- Inherited from SuiScoreView.defaultStaffMap

  - Defined in src/render/sui/scoreView.ts:372

  Show all staves, 1:1 mapping of view score staff to stored score staff

  #### Returns number[]

## Methods

### _changeActiveVoice

- _changeActiveVoice(index: number): SmoSelection[]

- - Defined in src/render/sui/scoreViewOperations.ts:366

  Change the active voice in a multi-voice measure.

  #### Parameters

  - ##### index: number

  #### Returns SmoSelection[]

### _getEquivalentGraceNote

- _getEquivalentGraceNote(selection: SmoSelection, gn: SmoGraceNote): SmoGraceNote

- Inherited from SuiScoreView._getEquivalentGraceNote

  - Defined in src/render/sui/scoreView.ts:330

  Get the equivalent selection from this.storeScore that maps to the displayed selection from this.score

  #### Parameters

  - ##### selection: SmoSelection

  - ##### gn: SmoGraceNote

  #### Returns SmoGraceNote

### _getEquivalentSelection

- _getEquivalentSelection(selection: SmoSelection): null | SmoSelection

- Inherited from SuiScoreView._getEquivalentSelection

  - Defined in src/render/sui/scoreView.ts:308

  Get the equivalent selection from this.storeScore that maps to the displayed selection from this.score

  #### Parameters

  - ##### selection: SmoSelection

  #### Returns null | SmoSelection

### _getEquivalentSelections

- _getEquivalentSelections(selections: SmoSelection[]): SmoSelection[]

- Inherited from SuiScoreView._getEquivalentSelections

  - Defined in src/render/sui/scoreView.ts:132

  The plural form of _getEquivalentSelection

  #### Parameters

  - ##### selections: SmoSelection[]

  #### Returns SmoSelection[]

### _getEquivalentSelector

- _getEquivalentSelector(selector: SmoSelector): any

- Inherited from SuiScoreView._getEquivalentSelector

  - Defined in src/render/sui/scoreView.ts:290

  Get the selector from this.storeScore that maps to the displayed selector from this.score

  #### Parameters

  - ##### selector: SmoSelector

  #### Returns any

### _getEquivalentStaff

- _getEquivalentStaff(staffId: number): number

- Inherited from SuiScoreView._getEquivalentStaff

  - Defined in src/render/sui/scoreView.ts:300

  Get the equivalent staff id from this.storeScore that maps to the displayed selector from this.score

  #### Parameters

  - ##### staffId: number

  #### Returns number

### _getRectangleSelections

- _getRectangleSelections(startSelector: SmoSelector, endSelector: SmoSelector): SmoSelection[]

- Inherited from SuiScoreView._getRectangleSelections

  - Defined in src/render/sui/scoreView.ts:346

  Get the rectangle of selections indicated by the parameters from the score

  #### Parameters

  - ##### startSelector: SmoSelector

  - ##### endSelector: SmoSelector

  #### Returns SmoSelection[]

### _mapPartFormatting

- _mapPartFormatting(): void

- Inherited from SuiScoreView._mapPartFormatting

  - Defined in src/render/sui/scoreView.ts:447

  Parts have different formatting options from the parent score, indluding layout. Reset them when exposing a part.

  #### Returns void

### _removeDynamic

- _removeDynamic(selection: SmoSelection, dynamic: SmoDynamicText): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:236

  Remove dynamics from the selection

  #### Parameters

  - ##### selection: SmoSelection

  - ##### dynamic: SmoDynamicText

  #### Returns Promise<void>

### _renderChangedMeasures

- _renderChangedMeasures(measureSelections: SmoSelection[]): void

- Inherited from SuiScoreView._renderChangedMeasures

  - Defined in src/render/sui/scoreView.ts:256

  Update renderer for measures that have changed

  #### Parameters

  - ##### measureSelections: SmoSelection[]

  #### Returns void

### _renderRectangle

- _renderRectangle(fromSelector: SmoSelector, toSelector: SmoSelector): void

- Inherited from SuiScoreView._renderRectangle

  - Defined in src/render/sui/scoreView.ts:269

  Update renderer for some columns

  #### Parameters

  - ##### fromSelector: SmoSelector

  - ##### toSelector: SmoSelector

  #### Returns void

### _setPageLayout

- _setPageLayout(layout: SmoPageLayout, pageIndex: number): void

- - Defined in src/render/sui/scoreViewOperations.ts:1332

  Set the layout of a single page

  #### Parameters

  - ##### layout: SmoPageLayout

    page layout

  - ##### pageIndex: number

    which page to change

  #### Returns void

### _setTransposing

- _setTransposing(): void

- Inherited from SuiScoreView._setTransposing

  - Defined in src/render/sui/scoreView.ts:522

  Update score based on transposing flag.

  #### Returns void

### _undoColumn

- _undoColumn(label: string, measureIndex: number): void

- Inherited from SuiScoreView._undoColumn

  - Defined in src/render/sui/scoreView.ts:176

  Create a rectangle undo, like a multiple columns but not necessarily the whole score.

  #### Parameters

  - ##### label: string

  - ##### measureIndex: number

  #### Returns void

### _undoFirstMeasureSelection

- _undoFirstMeasureSelection(label: string): SmoSelection

- Inherited from SuiScoreView._undoFirstMeasureSelection

  - Defined in src/render/sui/scoreView.ts:211

  operation that only affects the first selection. Setup undo for the measure

  #### Parameters

  - ##### label: string

  #### Returns SmoSelection

### _undoScore

- _undoScore(label: string): void

- Inherited from SuiScoreView._undoScore

  - Defined in src/render/sui/scoreView.ts:279

  Setup undo for operation that affects the whole score

  #### Parameters

  - ##### label: string

  #### Returns void

### _undoScorePreferences

- _undoScorePreferences(label: string): void

- Inherited from SuiScoreView._undoScorePreferences

  - Defined in src/render/sui/scoreView.ts:185

  Score preferences don't affect the display, but they do have an undo

  #### Parameters

  - ##### label: string

  #### Returns void

### _undoSelection

- _undoSelection(label: string, selection: SmoSelection): void

- Inherited from SuiScoreView._undoSelection

  - Defined in src/render/sui/scoreView.ts:227

  Add the selection to the undo buffer

  #### Parameters

  - ##### label: string

  - ##### selection: SmoSelection

  #### Returns void

### _undoSelections

- _undoSelections(label: string, selections: SmoSelection[]): void

- Inherited from SuiScoreView._undoSelections

  - Defined in src/render/sui/scoreView.ts:243

  Add multiple selections to the undo buffer as a group

  #### Parameters

  - ##### label: string

  - ##### selections: SmoSelection[]

  #### Returns void

### _undoStaffModifier

- _undoStaffModifier(label: string, staffModifier: StaffModifierBase, subtype: number): void

- Inherited from SuiScoreView._undoStaffModifier

  - Defined in src/render/sui/scoreView.ts:148

  A staff modifier has changed, create undo operations for the measures affected

  #### Parameters

  - ##### label: string

  - ##### staffModifier: StaffModifierBase

  - ##### subtype: number

  #### Returns void

### _undoTrackerMeasureSelections

- _undoTrackerMeasureSelections(label: string): SmoSelection[]

- Inherited from SuiScoreView._undoTrackerMeasureSelections

  - Defined in src/render/sui/scoreView.ts:195

  Add to the undo buffer the current set of measures selected.

  #### Parameters

  - ##### label: string

  #### Returns SmoSelection[]

### accelerando

- accelerando(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1248

  Add crescendo to selection

  #### Returns Promise<void>

### addDynamic

- addDynamic(selection: SmoSelection, dynamic: SmoDynamicText): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:221

  Modify the dynamics assoicated with the specific selection

  #### Parameters

  - ##### selection: SmoSelection

  - ##### dynamic: SmoDynamicText

  #### Returns Promise<void>

### addEnding

- addEnding(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1051

  Add a volta for selected measures

  #### Returns Promise<void>

### addGraceNote

- addGraceNote(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:540

  Add a grace note to the selected real notes.

  #### Returns Promise<void>

### addKeySignature

- addKeySignature(keySignature: string): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:893

  change key signature for selected measures

  #### Parameters

  - ##### keySignature: string

    vex key signature

  #### Returns Promise<void>

### addMeasure

- addMeasure(append: boolean): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1471

  add a single measure before or after selection

  #### Parameters

  - ##### append: boolean

  #### Returns Promise<void>

### addMeasures

- addMeasures(append: boolean, numberToAdd: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1445

  add number of measures, with default notes selections

  #### Parameters

  - ##### append: boolean

  - ##### numberToAdd: number

  #### Returns Promise<void>

### addOrUpdateStaffGroup

- addOrUpdateStaffGroup(staffGroup: SmoSystemGroup): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:449

  Update the staff group for a score, which determines how the staves are justified and bracketed

  #### Parameters

  - ##### staffGroup: SmoSystemGroup

  #### Returns Promise<void>

### addOrUpdateStaffModifier

- addOrUpdateStaffModifier(original: StaffModifierBase, modifier: StaffModifierBase): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1176

  Change a staff modifier

  #### Parameters

  - ##### original: StaffModifierBase

    original version

  - ##### modifier: StaffModifierBase

    modified version

  #### Returns Promise<void>

### addRemoveMicrotone

- addRemoveMicrotone(tone: SmoMicrotone): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:205

  Add a specific microtone modifier to the selected notes

  #### Parameters

  - ##### tone: SmoMicrotone

  #### Returns Promise<void>

### addStaffSimple

- addStaffSimple(params: Partial<SmoInstrumentParams>): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1553

  A simpler API for applications to add a new staff to the score.

  #### Parameters

  - ##### params: Partial<SmoInstrumentParams>

    the instrument, which determines clef, etc.

  #### Returns Promise<void>

### addTextGroup

- addTextGroup(textGroup: SmoTextGroup): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:50

  Add a new text group to the score

  #### Parameters

  - ##### textGroup: SmoTextGroup

    a new text group

  #### Returns Promise<void>

### advanceModifierSelection

- advanceModifierSelection(keyEv: KeyEvent): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1691

  Select the next tabbable modifier near one of the selected notes

  #### Parameters

  - ##### keyEv: KeyEvent

  #### Returns Promise<any>

### batchDurationOperation

- batchDurationOperation(operation: BatchSelectionOperation): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:702

  change the duration of notes for selected, creating more or fewer notes. After the change, reset the selection so it's as close as possible to the original length

  #### Parameters

  - ##### operation: BatchSelectionOperation

  #### Returns Promise<void>

### beamSelections

- beamSelections(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:881

  Add the selected notes to a beam group

  #### Returns Promise<void>

### changeInstrument

- changeInstrument(instrument: SmoInstrument, selections: SmoSelection[]): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:404

  Assign an instrument to a set of measures

  #### Parameters

  - ##### instrument: SmoInstrument

    the instrument to assign to the selections

  - ##### selections: SmoSelection[]

  #### Returns Promise<void>

### changeScore

- changeScore(score: SmoScore): Promise<any>

- Inherited from SuiScoreView.changeScore

  - Defined in src/render/sui/scoreView.ts:536

  Update the view after loading or restoring a completely new score

  #### Parameters

  - ##### score: SmoScore

  #### Returns Promise<any>

### collapseChord

- collapseChord(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:802

  change the selected chord into a single note

  #### Returns Promise<void>

### copy

- copy(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1005

  Generic clipboard copy action

  #### Returns Promise<void>

### crescendo

- crescendo(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1227

  Add crescendo to selection

  #### Returns Promise<void>

### crescendoBracket

- crescendoBracket(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1234

  Add crescendo to selection

  #### Returns Promise<void>

### decrescendo

- decrescendo(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1263

  diminuendo selections

  #### Returns Promise<void>

### deleteMeasure

- deleteMeasure(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1405

  delete selected measures

  #### Returns Promise<any>

### deleteNote

- deleteNote(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:268

  we never really delete a note, but we will convert it into a rest and if it's already a rest we will try to hide it. Operates on current selections

  #### Returns Promise<void>

### depopulateVoice

- depopulateVoice(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:347

  Delete all the notes for the currently selected voice

  #### Returns Promise<void>

### dimenuendo

- dimenuendo(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1241

  Add crescendo to selection

  #### Returns Promise<void>

### exposePart

- exposePart(staff: SmoSystemStaff): void

- Inherited from SuiScoreView.exposePart

  - Defined in src/render/sui/scoreView.ts:424

  Exposes a part: hides non-part staves, shows part staves. Note this will reset the view. After this operation, staff 0 will be the selected part.

  #### Parameters

  - ##### staff: SmoSystemStaff

  #### Returns void

### getFocusedPage

- getFocusedPage(): number

- Inherited from SuiScoreView.getFocusedPage

  - Defined in src/render/sui/scoreView.ts:160

  Return the index of the page that is in the center of the client screen.

  #### Returns number

### getView

- getView(): ViewMapEntry[]

- Inherited from SuiScoreView.getView

  - Defined in src/render/sui/scoreView.ts:396

  Gets the current mapping of displayed staves to score staves (this.storeScore)

  #### Returns ViewMapEntry[]

### groupUndo

- groupUndo(val: boolean): void

- Inherited from SuiScoreView.groupUndo

  - Defined in src/render/sui/scoreView.ts:364

  set the grouping flag for undo operations

  #### Parameters

  - ##### val: boolean

  #### Returns void

### growSelectionLeft

- growSelectionLeft(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1673

  Grow the current selection by one to the left, if possible

  #### Returns Promise<any>

### growSelectionRight

- growSelectionRight(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1682

  Grow the current selection by one to the right, if possible

  #### Returns Promise<any>

### growSelectionRightMeasure

- growSelectionRightMeasure(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1699

  Select the next entire measure, if possible

  #### Returns Promise<any>

### intersectingArtifact

- intersectingArtifact(evData: SvgBox): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1779

  Find an element at the given box, and make it the current selection

  #### Parameters

  - ##### evData: SvgBox

  #### Returns Promise<any>

### isPartExposed

- isPartExposed(): boolean

- Inherited from SuiScoreView.isPartExposed

  - Defined in src/render/sui/scoreView.ts:440

  Indicates if the score is displaying in part-mode vs. score mode.

  #### Returns boolean

### loadRemoteJson

- loadRemoteJson(url: string): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:141

  load a remote score in SMO format

  #### Parameters

  - ##### url: string

    url to find the score

  #### Returns Promise<any>

### loadRemoteScore

- loadRemoteScore(url: string): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:155

  Load a remote score, return promise when it's been loaded from afar.

  #### Parameters

  - ##### url: string

  #### Returns Promise<any>

### loadRemoteXml

- loadRemoteXml(url: string): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:125

  load an mxml score remotely, return a promise that completes when the file is loaded

  #### Parameters

  - ##### url: string

    where to find the xml file

  #### Returns Promise<any>

### makeRest

- makeRest(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:837

  make selected notes into a rest, or visa-versa

  #### Returns Promise<void>

### makeTuplet

- makeTuplet(numNotes: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:759

  convert non-tuplet not to a tuplet

  #### Parameters

  - ##### numNotes: number

    3 means triplet, etc.

  #### Returns Promise<void>

### moveEnd

- moveEnd(ev: KeyEvent): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1664

  Proxy calls to move the tracker parameters according to the rules of the 'End' key (depending on shift/ctrl/alt)

  #### Parameters

  - ##### ev: KeyEvent

  #### Returns Promise<any>

### moveHome

- moveHome(ev: KeyEvent): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1654

  Proxy calls to move the tracker parameters according to the rules of the 'Home' key (depending on shift/ctrl/alt)

  #### Parameters

  - ##### ev: KeyEvent

  #### Returns Promise<any>

### moveSelectionDown

- moveSelectionDown(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1764

  Move cursor down a staff in the system, if possible

  #### Returns Promise<any>

### moveSelectionLeft

- moveSelectionLeft(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1717

  Advance cursor backwards, if possible

  #### Returns Promise<any>

### moveSelectionLeftMeasure

- moveSelectionLeftMeasure(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1725

  Advance cursor back entire measure, if possible

  #### Returns Promise<any>

### moveSelectionPitchDown

- moveSelectionPitchDown(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1748

  Move cursor to a lower pitch in the current chord, with wrap

  #### Returns Promise<any>

### moveSelectionPitchUp

- moveSelectionPitchUp(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1741

  Move cursor to a higher pitch in the current chord, with wrap

  #### Returns Promise<any>

### moveSelectionRight

- moveSelectionRight(ev: KeyEvent): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1708

  Advance cursor forwards, if possible

  #### Parameters

  - ##### ev: KeyEvent

  #### Returns Promise<any>

### moveSelectionRightMeasure

- moveSelectionRightMeasure(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1733

  Advance cursor forward one measure, if possible

  #### Returns Promise<any>

### moveSelectionUp

- moveSelectionUp(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1756

  Move cursor up a staff in the system, if possible

  #### Returns Promise<any>

### moveStaffUpDown

- moveStaffUpDown(index: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:434

  Move selected staff up or down in the score.

  #### Parameters

  - ##### index: number

    direction to move

  #### Returns Promise<void>

### paste

- paste(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1021

  clipboard paste action

  #### Returns Promise<void>

### playFromSelection

- playFromSelection(): void

- - Defined in src/render/sui/scoreViewOperations.ts:1630

  Play the music from the starting selection

  #### Returns void

### populateVoice

- populateVoice(index: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:381

  Populate a new voice with default notes

  #### Parameters

  - ##### index: number

    the voice to populate

  #### Returns Promise<void>

### quickSave

- quickSave(): void

- - Defined in src/render/sui/scoreViewOperations.ts:1566

  Save the score to local storage.

  #### Returns void

### refreshViewport

- refreshViewport(): Promise<any>

- Inherited from SuiScoreView.refreshViewport

  - Defined in src/render/sui/scoreView.ts:95

  await on the full update of the score, also resetting the viewport (to reflect layout changes)

  #### Returns Promise<any>

### removeDynamic

- removeDynamic(dynamic: SmoDynamicText): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:252

  Remove dynamics from the current selection

  #### Parameters

  - ##### dynamic: SmoDynamicText

  #### Returns Promise<void>

### removeGraceNote

- removeGraceNote(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:569

  remove selected grace note

  #### Returns Promise<void>

### removeLyric

- removeLyric(selector: SmoSelector, lyric: SmoLyric): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:307

  The lyric editor moves around, so we can't depend on the tracker for the correct selection. We get it directly from the editor.

  #### Parameters

  - ##### selector: SmoSelector

    the selector of the note with the lyric to remove

  - ##### lyric: SmoLyric

    a copy of the lyric to remove. We use the verse, parser to identify it

  #### Returns Promise<void>

  render promise

### removeStaff

- removeStaff(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1495

  remove an entire line of music

  #### Returns Promise<void>

### removeStaffModifier

- removeStaffModifier(modifier: StaffModifierBase): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1163

  Remove selected modifier

  #### Parameters

  - ##### modifier: StaffModifierBase

    slur, hairpin, etc.

  #### Returns Promise<void>

### removeSystemBreaks

- removeSystemBreaks(): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1601

  Remove system breaks from the measure formatting for selected measures

  #### Returns Promise<any>

### removeTempo

- removeTempo(measure: SmoMeasure, tempo: SmoTempoText, scoreMode: boolean, selectionMode: boolean): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:523

  'remove' tempo, which means either setting the bars to the default tempo, or the previously-set tempo.

  #### Parameters

  - ##### measure: SmoMeasure

  - ##### tempo: SmoTempoText

  - ##### scoreMode: boolean

    whether to reset entire score

  - ##### selectionMode: boolean

  #### Returns Promise<void>

### removeTextGroup

- removeTextGroup(textGroup: SmoTextGroup): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:65

  Remove the text group from the score

  #### Parameters

  - ##### textGroup: SmoTextGroup

  #### Returns Promise<void>

### renderPromise

- renderPromise(): Promise<any>

- Inherited from SuiScoreView.renderPromise

  - Defined in src/render/sui/scoreView.ts:81

  Await on the full update of the score

  #### Returns Promise<any>

### ritard

- ritard(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1255

  Add crescendo to selection

  #### Returns Promise<void>

### selectSuggestion

- selectSuggestion(evData: KeyEvent): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1772

  Set the current suggestions (hover element) as the selection

  #### Parameters

  - ##### evData: KeyEvent

  #### Returns Promise<any>

### setChordFont

- setChordFont(fontInfo: FontInfo): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1371

  Upate global font used for chord changes

  #### Parameters

  - ##### fontInfo: FontInfo

  #### Returns Promise<void>

### setEngravingFontFamily

- setEngravingFontFamily(family: engravingFontType): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1359

  Update the music font

  #### Parameters

  - ##### family: engravingFontType

  #### Returns Promise<void>

### setGlobalLayout

- setGlobalLayout(layout: SmoGlobalLayout): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1317

  set global page for score, zoom etc.

  #### Parameters

  - ##### layout: SmoGlobalLayout

    global SVG settings

  #### Returns Promise<void>

### setInterval

- setInterval(interval: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:786

  Create a chord by adding an interval to selected note

  #### Parameters

  - ##### interval: number

    1/2 steps

  #### Returns Promise<void>

### setLyricFont

- setLyricFont(fontInfo: FontInfo): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1383

  Update font used for lyrics

  #### Parameters

  - ##### fontInfo: FontInfo

  #### Returns Promise<void>

### setMappedStaffIds

- setMappedStaffIds(): void

- Inherited from SuiScoreView.setMappedStaffIds

  - Defined in src/render/sui/scoreView.ts:408

  Update the staff ID when the view changes

  #### Returns void

### setMeasureFormat

- setMeasureFormat(format: SmoMeasureFormat): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:1575

  Update the measure formatting parameters for the current selection

  #### Parameters

  - ##### format: SmoMeasureFormat

    generic measure formatting parameters

  #### Returns Promise<any>

### setNoteHead

- setNoteHead(head: string): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1039

  specify a note head other than the default for the duration

  #### Parameters

  - ##### head: string

  #### Returns Promise<void>

### setPitch

- setPitch(letter: PitchLetter): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:972

  Add a pitch to the score at the cursor. This tries to find the best pitch to match the letter key (F vs F# for instance) based on key and surrounding notes

  #### Parameters

  - ##### letter: PitchLetter

    string

  #### Returns Promise<void>

### setPitchPiano

- setPitchPiano(pitch: Pitch, chordPedal: boolean): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:908

  Sets a pitch from the piano widget.

  #### Parameters

  - ##### pitch: Pitch

  - ##### chordPedal: boolean

    indicates we are adding to a chord

  #### Returns Promise<void>

### setPitchesPromise

- setPitchesPromise(pitches: PitchLetter[]): Promise<any>

- - Defined in src/render/sui/scoreViewOperations.ts:950

  Render a pitch for each letter name-pitch in the string,

  see

    setPitch

  #### Parameters

  - ##### pitches: PitchLetter[]

    letter names for pitches

  #### Returns Promise<any>

  promise, resolved when all pitches rendered

### setTimeSignature

- setTimeSignature(timeSignature: TimeSignature, timeSignatureString: string): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:420

  Set the time signature for a selection

  #### Parameters

  - ##### timeSignature: TimeSignature

    actual time signature

  - ##### timeSignatureString: string

    display time signature if different, as in for pickup notes

  #### Returns Promise<void>

### setView

- setView(rows: ViewMapEntry[]): void

- Inherited from SuiScoreView.setView

  - Defined in src/render/sui/scoreView.ts:466

  Update the list of staves in the score that are displayed.

  #### Parameters

  - ##### rows: ViewMapEntry[]

  #### Returns void

### showPiano

- showPiano(value: boolean): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:934

  show or hide the piano widget

  #### Parameters

  - ##### value: boolean

    to show it

  #### Returns Promise<void>

### slashGraceNotes

- slashGraceNotes(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:584

  Toggle slash in stem of grace note

  #### Returns Promise<void>

### slur

- slur(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1292

  Slur selected notes

  #### Returns Promise<void>

### startRenderingEngine

- startRenderingEngine(): void

- Inherited from SuiScoreView.startRenderingEngine

  - Defined in src/render/sui/scoreView.ts:383

  Bootstrapping function, creates the renderer and associated timers

  #### Returns void

### tie

- tie(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1308

  tie selected notes

  #### Returns Promise<void>

### toggleArticulation

- toggleArticulation(modifier: string, ctor: string): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:732

  Toggle selected modifier on selected notes

  #### Parameters

  - ##### modifier: string

  - ##### ctor: string

    parent class constructor (e.g. SmoOrnament)

  #### Returns Promise<void>

### toggleBeamDirection

- toggleBeamDirection(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:867

  up or down

  #### Returns Promise<void>

### toggleBeamGroup

- toggleBeamGroup(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:852

  toggle the 'end beam' flag for selected notes

  #### Returns Promise<void>

### toggleCourtesyAccidentals

- toggleCourtesyAccidentals(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:671

  Toggle cautionary/courtesy accidentals

  #### Returns Promise<void>

### toggleEnharmonic

- toggleEnharmonic(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:642

  toggle the accidental spelling of the selected notes

  #### Returns Promise<void>

### toggleRehearsalMark

- toggleRehearsalMark(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1142

  toggle rehearsal mark on first selected measure

  #### Returns Promise<void>

### toggleSlash

- toggleSlash(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:822

  Toggle chicken-scratches, for jazz improv, comping etc.

  #### Returns Promise<void>

### transposeSelections

- transposeSelections(offset: number): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:607

  transpose selected notes

  #### Parameters

  - ##### offset: number

    1/2 steps

  #### Returns Promise<void>

### undo

- undo(): void

- Inherited from SuiScoreView.undo

  - Defined in src/render/sui/scoreView.ts:555

  for the view score, the renderer decides what to render depending on what is undone.

  #### Returns void

### unmakeTuplet

- unmakeTuplet(): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:771

  Convert selected tuplet to a single (if possible) non-tuplet

  #### Returns Promise<void>

### updatePartInfo

- updatePartInfo(info: SmoPartInfo): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:1523

  Update part info assumes that the part is currently exposed - that staff 0 is the first staff in the part prior to editing.

  #### Parameters

  - ##### info: SmoPartInfo

  #### Returns Promise<void>

### updatePromise

- updatePromise(): Promise<any>

- Inherited from SuiScoreView.updatePromise

  - Defined in src/render/sui/scoreView.ts:88

  Await on the partial update of the score in the view

  #### Returns Promise<any>

### updateScoreInfo

- updateScoreInfo(scoreInfo: SmoScoreInfo): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:193

  Update information about the score, composer etc.

  #### Parameters

  - ##### scoreInfo: SmoScoreInfo

  #### Returns Promise<void>

### updateScorePreferences

- updateScorePreferences(pref: SmoScorePreferences): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:174

  Global settings that control how the score editor behaves

  #### Parameters

  - ##### pref: SmoScorePreferences

  #### Returns Promise<void>

### updateTempoScore

- updateTempoScore(measure: SmoMeasure, tempo: SmoTempoText, scoreMode: boolean, selectionMode: boolean): Promise<void>

- - Defined in src/render/sui/scoreViewOperations.ts:464

  UPdate tempo for all or part of the score

  #### Parameters

  - ##### measure: SmoMeasure

    the measure with the tempo. Tempo is measure-wide parameter

  - ##### tempo: SmoTempoText

  - ##### scoreMode: boolean

    if true, update whole score. Else selections

  - ##### selectionMode: boolean

  #### Returns Promise<void>

### updateTextGroup

- updateTextGroup(oldVersion: SmoTextGroup, newVersion: SmoTextGroup): void

- - Defined in src/render/sui/scoreViewOperations.ts:94

  UPdate an existing text group. The original is passed in, because since TG not tied to a musical element, we need to find the one we're updating.

  #### Parameters

  - ##### oldVersion: SmoTextGroup

  - ##### newVersion: SmoTextGroup

  #### Returns void

### viewAll

- viewAll(): void

- Inherited from SuiScoreView.viewAll

  - Defined in src/render/sui/scoreView.ts:511

  view all the staffs in score mode.

  #### Returns void

### waitableAction

- waitableAction(action: (() => void), repetition?: number): Promise<any>

- Inherited from SuiScoreView.waitableAction

  - Defined in src/render/sui/scoreView.ts:108

  This is used in some Smoosic demos and pens.

  #### Parameters

  - ##### action: (() => void)

    any action, but most usefully a SuiScoreView method

    - - (): void

      - #### Returns void

  - ##### Optional repetition: number

    number of times to repeat, waiting on render promise between if not specified, defaults to 1

  #### Returns Promise<any>

  promise, resolved action has been completed and score is updated.

Generated using TypeDoc